diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..7f7a796 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -4008,24 +4007,24 @@ namespace {
         }
         
         /**
-         * Get a base query builder instance.
+         * Set the underlying query builder instance.
          *
-         * @return \Illuminate\Database\Query\Builder 
+         * @param \Illuminate\Database\Query\Builder $query
+         * @return $this 
          * @static 
          */
-        public static function toBase(){
-            return \Illuminate\Database\Eloquent\Builder::toBase();
+        public static function setQuery($query){
+            return \Illuminate\Database\Eloquent\Builder::setQuery($query);
         }
         
         /**
-         * Set the underlying query builder instance.
+         * Get a base query builder instance.
          *
-         * @param \Illuminate\Database\Query\Builder $query
-         * @return $this 
+         * @return \Illuminate\Database\Query\Builder 
          * @static 
          */
-        public static function setQuery($query){
-            return \Illuminate\Database\Eloquent\Builder::setQuery($query);
+        public static function toBase(){
+            return \Illuminate\Database\Eloquent\Builder::toBase();
         }
         
         /**
@@ -4071,18 +4070,6 @@ namespace {
         }
         
         /**
-         * Extend the builder with a given callback.
-         *
-         * @param string $name
-         * @param \Closure $callback
-         * @return void 
-         * @static 
-         */
-        public static function macro($name, $callback){
-            \Illuminate\Database\Eloquent\Builder::macro($name, $callback);
-        }
-        
-        /**
          * Get the given macro by name.
          *
          * @param string $name
@@ -4094,40 +4081,204 @@ namespace {
         }
         
         /**
-         * Set the columns to be selected.
+         * Chunk the results of the query.
          *
-         * @param array|mixed $columns
-         * @return $this 
+         * @param int $count
+         * @param callable $callback
+         * @return bool 
          * @static 
          */
-        public static function select($columns = array()){
-            return \Illuminate\Database\Query\Builder::select($columns);
+        public static function chunk($count, $callback){
+            return \Illuminate\Database\Eloquent\Builder::chunk($count, $callback);
         }
         
         /**
-         * Add a new "raw" select expression to the query.
+         * Execute a callback over each item while chunking.
          *
-         * @param string $expression
-         * @param array $bindings
-         * @return \Illuminate\Database\Query\Builder|static 
+         * @param callable $callback
+         * @param int $count
+         * @return bool 
          * @static 
          */
-        public static function selectRaw($expression, $bindings = array()){
-            return \Illuminate\Database\Query\Builder::selectRaw($expression, $bindings);
+        public static function each($callback, $count = 1000){
+            return \Illuminate\Database\Eloquent\Builder::each($callback, $count);
         }
         
         /**
-         * Add a subselect expression to the query.
+         * Execute the query and get the first result.
          *
-         * @param \Closure|\Illuminate\Database\Query\Builder|string $query
-         * @param string $as
-         * @return \Illuminate\Database\Query\Builder|static 
-         * @throws \InvalidArgumentException
+         * @param array $columns
+         * @return mixed 
          * @static 
          */
-        public static function selectSub($query, $as){
-            return \Illuminate\Database\Query\Builder::selectSub($query, $as);
-        }
+        public static function first($columns = array()){
+            return \Illuminate\Database\Eloquent\Builder::first($columns);
+        }
+        
+        /**
+         * Apply the callback's query changes if the given "value" is true.
+         *
+         * @param mixed $value
+         * @param callable $callback
+         * @param callable $default
+         * @return mixed 
+         * @static 
+         */
+        public static function when($value, $callback, $default = null){
+            return \Illuminate\Database\Eloquent\Builder::when($value, $callback, $default);
+        }
+        
+        /**
+         * Apply the callback's query changes if the given "value" is false.
+         *
+         * @param mixed $value
+         * @param callable $callback
+         * @param callable $default
+         * @return mixed 
+         * @static 
+         */
+        public static function unless($value, $callback, $default = null){
+            return \Illuminate\Database\Eloquent\Builder::unless($value, $callback, $default);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query.
+         *
+         * @param string $relation
+         * @param string $operator
+         * @param int $count
+         * @param string $boolean
+         * @param \Closure|null $callback
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function has($relation, $operator = '>=', $count = 1, $boolean = 'and', $callback = null){
+            return \Illuminate\Database\Eloquent\Builder::has($relation, $operator, $count, $boolean, $callback);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query with an "or".
+         *
+         * @param string $relation
+         * @param string $operator
+         * @param int $count
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function orHas($relation, $operator = '>=', $count = 1){
+            return \Illuminate\Database\Eloquent\Builder::orHas($relation, $operator, $count);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query.
+         *
+         * @param string $relation
+         * @param string $boolean
+         * @param \Closure|null $callback
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function doesntHave($relation, $boolean = 'and', $callback = null){
+            return \Illuminate\Database\Eloquent\Builder::doesntHave($relation, $boolean, $callback);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query with where clauses.
+         *
+         * @param string $relation
+         * @param \Closure|null $callback
+         * @param string $operator
+         * @param int $count
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function whereHas($relation, $callback = null, $operator = '>=', $count = 1){
+            return \Illuminate\Database\Eloquent\Builder::whereHas($relation, $callback, $operator, $count);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query with where clauses and an "or".
+         *
+         * @param string $relation
+         * @param \Closure $callback
+         * @param string $operator
+         * @param int $count
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function orWhereHas($relation, $callback = null, $operator = '>=', $count = 1){
+            return \Illuminate\Database\Eloquent\Builder::orWhereHas($relation, $callback, $operator, $count);
+        }
+        
+        /**
+         * Add a relationship count / exists condition to the query with where clauses.
+         *
+         * @param string $relation
+         * @param \Closure|null $callback
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function whereDoesntHave($relation, $callback = null){
+            return \Illuminate\Database\Eloquent\Builder::whereDoesntHave($relation, $callback);
+        }
+        
+        /**
+         * Add subselect queries to count the relations.
+         *
+         * @param mixed $relations
+         * @return $this 
+         * @static 
+         */
+        public static function withCount($relations){
+            return \Illuminate\Database\Eloquent\Builder::withCount($relations);
+        }
+        
+        /**
+         * Merge the where constraints from another query to the current query.
+         *
+         * @param \Illuminate\Database\Eloquent\Builder $from
+         * @return \Illuminate\Database\Eloquent\Builder|static 
+         * @static 
+         */
+        public static function mergeConstraintsFrom($from){
+            return \Illuminate\Database\Eloquent\Builder::mergeConstraintsFrom($from);
+        }
+        
+        /**
+         * Set the columns to be selected.
+         *
+         * @param array|mixed $columns
+         * @return $this 
+         * @static 
+         */
+        public static function select($columns = array()){
+            return \Illuminate\Database\Query\Builder::select($columns);
+        }
+        
+        /**
+         * Add a new "raw" select expression to the query.
+         *
+         * @param string $expression
+         * @param array $bindings
+         * @return \Illuminate\Database\Query\Builder|static 
+         * @static 
+         */
+        public static function selectRaw($expression, $bindings = array()){
+            return \Illuminate\Database\Query\Builder::selectRaw($expression, $bindings);
+        }
+        
+        /**
+         * Add a subselect expression to the query.
+         *
+         * @param \Closure|\Illuminate\Database\Query\Builder|string $query
+         * @param string $as
+         * @return \Illuminate\Database\Query\Builder|static 
+         * @throws \InvalidArgumentException
+         * @static 
+         */
+        public static function selectSub($query, $as){
+            return \Illuminate\Database\Query\Builder::selectSub($query, $as);
+        }
         
         /**
          * Add a new select column to the query.
@@ -4165,31 +4316,31 @@ namespace {
          * Add a join clause to the query.
          *
          * @param string $table
-         * @param string $one
+         * @param string $first
          * @param string $operator
-         * @param string $two
+         * @param string $second
          * @param string $type
          * @param bool $where
          * @return $this 
          * @static 
          */
-        public static function join($table, $one, $operator = null, $two = null, $type = 'inner', $where = false){
-            return \Illuminate\Database\Query\Builder::join($table, $one, $operator, $two, $type, $where);
+        public static function join($table, $first, $operator = null, $second = null, $type = 'inner', $where = false){
+            return \Illuminate\Database\Query\Builder::join($table, $first, $operator, $second, $type, $where);
         }
         
         /**
          * Add a "join where" clause to the query.
          *
          * @param string $table
-         * @param string $one
+         * @param string $first
          * @param string $operator
-         * @param string $two
+         * @param string $second
          * @param string $type
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function joinWhere($table, $one, $operator, $two, $type = 'inner'){
-            return \Illuminate\Database\Query\Builder::joinWhere($table, $one, $operator, $two, $type);
+        public static function joinWhere($table, $first, $operator, $second, $type = 'inner'){
+            return \Illuminate\Database\Query\Builder::joinWhere($table, $first, $operator, $second, $type);
         }
         
         /**
@@ -4210,14 +4361,14 @@ namespace {
          * Add a "join where" clause to the query.
          *
          * @param string $table
-         * @param string $one
+         * @param string $first
          * @param string $operator
-         * @param string $two
+         * @param string $second
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function leftJoinWhere($table, $one, $operator, $two){
-            return \Illuminate\Database\Query\Builder::leftJoinWhere($table, $one, $operator, $two);
+        public static function leftJoinWhere($table, $first, $operator, $second){
+            return \Illuminate\Database\Query\Builder::leftJoinWhere($table, $first, $operator, $second);
         }
         
         /**
@@ -4238,14 +4389,14 @@ namespace {
          * Add a "right join where" clause to the query.
          *
          * @param string $table
-         * @param string $one
+         * @param string $first
          * @param string $operator
-         * @param string $two
+         * @param string $second
          * @return \Illuminate\Database\Query\Builder|static 
          * @static 
          */
-        public static function rightJoinWhere($table, $one, $operator, $two){
-            return \Illuminate\Database\Query\Builder::rightJoinWhere($table, $one, $operator, $two);
+        public static function rightJoinWhere($table, $first, $operator, $second){
+            return \Illuminate\Database\Query\Builder::rightJoinWhere($table, $first, $operator, $second);
         }
         
         /**
@@ -4263,6 +4414,29 @@ namespace {
         }
         
         /**
+         * Pass the query to a given callback.
+         *
+         * @param \Closure $callback
+         * @return \Illuminate\Database\Query\Builder 
+         * @static 
+         */
+        public static function tap($callback){
+            return \Illuminate\Database\Query\Builder::tap($callback);
+        }
+        
+        /**
+         * Merge an array of where clauses and bindings.
+         *
+         * @param array $wheres
+         * @param array $bindings
+         * @return void 
+         * @static 
+         */
+        public static function mergeWheres($wheres, $bindings){
+            \Illuminate\Database\Query\Builder::mergeWheres($wheres, $bindings);
+        }
+        
+        /**
          * Add a "where" clause comparing two columns to the query.
          *
          * @param string|array $first
